//************************************************************************************
//**  
//**  File name:     D:\Controllers\flowcode\voltmeter\multi.c
//**  Generated by:  Flowcode v4.3.6.61
//**  Date:          Sunday, March 20, 2011 21:57:03
//**  Licence:       Professional
//**  Registered to: 20ACM8
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_EE
#define MX_EE_SIZE 512
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 4
#define MX_SPI_SDO 3
#define MX_SPI_SCK 5
#define MX_UART
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 5
#define MX_PWM
#define MX_PWM_PORT PORTB
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRB
#define MX_PWM_1 1
#define MX_PWM_TRIS2 DDRB
#define MX_PWM_2 2
#define MX_PWMTYPE 1

//Functions
#define F_CPU 8000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations
void FCM_tmr0();


//Variable declarations
#define FCSZ_UBAT 4
#define FCSZ_D_IIN 20
#define FCSZ_D_RPM 20
#define FCSZ_D_IBAT 20
#define FCSZ_UIN 4
#define FCSZ_D_UBAT 20
#define FCSZ_IIN 4
#define FCSZ_RPM 4
#define FCSZ_IBAT 4
#define FCSZ_D_UIN 20
volatile char FCV_UBAT[FCSZ_UBAT];
volatile char FCV_D_IIN[FCSZ_D_IIN];
volatile char FCV_FLAG_T;
volatile char FCV_PORT_D2;
volatile char FCV_D_RPM[FCSZ_D_RPM];
volatile char FCV_D_IBAT[FCSZ_D_IBAT];
volatile char FCV_UIN[FCSZ_UIN];
volatile char FCV_D_UBAT[FCSZ_D_UBAT];
volatile char FCV_IIN[FCSZ_IIN];
volatile double FCV_FREQ_FLOAT;
volatile char FCV_RPM[FCSZ_RPM];
volatile char FCV_IBAT[FCSZ_IBAT];
volatile char FCV_D_UIN[FCSZ_D_UIN];
volatile char FCV_COUNT_T;
volatile short FCV_COUNT_D;
volatile short FCV_TIME;
volatile char FCV_FLAG_PD;


//Defines:

/**** Macro Substitutions ****
PORTB = D1 Port
DDRB = D1 Data Direction
PORTD = D2 Port
DDRD = D2 Data Direction
PORTD = D3 Port
DDRD = D3 Data Direction
PORTD = D4 Port
DDRD = D4 Data Direction
PORTB = RS Port
DDRB = RS Data Direction
PORTB = E Port
DDRB = E Data Direction
0 = Data 1_Pin
7 = Data 2 Pin
6 = Data 3 Pin
5 = Data 4 Pin
1 = RS Pin
2 = Enable Pin
LCD_5966508 = Unique Component Reference Number
2 = Row Count
40 = Column Count
******************************/

	//component connections
	#define LCD_5966508_PORT0    PORTB
	#define LCD_5966508_DDR0    DDRB
	#define LCD_5966508_PORT1    PORTD
	#define LCD_5966508_DDR1    DDRD
	#define LCD_5966508_PORT2    PORTD
	#define LCD_5966508_DDR2    DDRD
	#define LCD_5966508_PORT3    PORTD
	#define LCD_5966508_DDR3    DDRD
	#define LCD_5966508_PORT4    PORTB
	#define LCD_5966508_DDR4    DDRB
	#define LCD_5966508_PORT5    PORTB
	#define LCD_5966508_DDR5    DDRB
	#define LCD_5966508_BIT0    	0
	#define LCD_5966508_BIT1    	7
	#define LCD_5966508_BIT2    	6
	#define LCD_5966508_BIT3    	5
	#define LCD_5966508_RS      	1
	#define LCD_5966508_E       	2
	#define LCD_5966508_ROWCNT	2
	#define LCD_5966508_COLCNT	40

    #define LCD_5966508_DELAY   delay_us(100)




//LCDDisplay(0): //Macro function declarations

static void FCD_LCDDisplay0_RawSend(char in, char mask);
static void FCD_LCDDisplay0_Start();
static void FCD_LCDDisplay0_Clear();
static void FCD_LCDDisplay0_PrintASCII(char Character);
static void FCD_LCDDisplay0_Command(char in);
static void FCD_LCDDisplay0_Cursor(char x, char y);
static void FCD_LCDDisplay0_PrintNumber(short Number);
static void FCD_LCDDisplay0_PrintString(char* String, char MSZ_String);
static void FCD_LCDDisplay0_ScrollDisplay(char Direction, char Num_Positions);
static void FCD_LCDDisplay0_ClearLine(char Line);
static void FCD_LCDDisplay0_RAM_Write(char nIdx, char d0, char d1, char d2, char d3, char d4, char d5, char d6, char d7);
//Defines:

/**** Macro Substitutions ****
0 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(0): //Macro function declarations

static void FCD_ADC0_SampleADC();
static char FCD_ADC0_ReadAsByte();
static short FCD_ADC0_ReadAsInt();
static float FCD_ADC0_ReadAsVoltage();
static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);
//Defines:

/**** Macro Substitutions ****
PORTD = LED Port Register
DDRD = LED Data Direction Register
1 = LED Pin Mask
1 = LED Active Polarity
******************************/




//LED(0): //Macro function declarations

static void FCD_LED0_LEDOn();
static void FCD_LED0_LEDOff();
//Defines:

/**** Macro Substitutions ****
1 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(1): //Macro function declarations

static void FCD_ADC1_SampleADC();
static char FCD_ADC1_ReadAsByte();
static short FCD_ADC1_ReadAsInt();
static float FCD_ADC1_ReadAsVoltage();
static void FCD_ADC1_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);
//Defines:

/**** Macro Substitutions ****
3 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(2): //Macro function declarations

static void FCD_ADC2_SampleADC();
static char FCD_ADC2_ReadAsByte();
static short FCD_ADC2_ReadAsInt();
static float FCD_ADC2_ReadAsVoltage();
static void FCD_ADC2_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);
//Defines:

/**** Macro Substitutions ****
2 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(3): //Macro function declarations

static void FCD_ADC3_SampleADC();
static char FCD_ADC3_ReadAsByte();
static short FCD_ADC3_ReadAsInt();
static float FCD_ADC3_ReadAsVoltage();
static void FCD_ADC3_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);



//LCDDisplay(0): //Macro implementations


static void FCD_LCDDisplay0_RawSend(char in, char mask)
{
		unsigned char pt;

		clear_bit(LCD_5966508_PORT0, LCD_5966508_BIT0);
		clear_bit(LCD_5966508_PORT1, LCD_5966508_BIT1);
		clear_bit(LCD_5966508_PORT2, LCD_5966508_BIT2);
		clear_bit(LCD_5966508_PORT3, LCD_5966508_BIT3);
		clear_bit(LCD_5966508_PORT4, LCD_5966508_RS);
		clear_bit(LCD_5966508_PORT5, LCD_5966508_E);
		pt = ((in >> 4) & 0x0f);
		if (pt & 0x01)
		    set_bit(LCD_5966508_PORT0, LCD_5966508_BIT0);
		if (pt & 0x02)
		    set_bit(LCD_5966508_PORT1, LCD_5966508_BIT1);
		if (pt & 0x04)
		    set_bit(LCD_5966508_PORT2, LCD_5966508_BIT2);
		if (pt & 0x08)
		    set_bit(LCD_5966508_PORT3, LCD_5966508_BIT3);
		if (mask)
		    set_bit(LCD_5966508_PORT4, LCD_5966508_RS);
		LCD_5966508_DELAY;
		set_bit (LCD_5966508_PORT5, LCD_5966508_E);
		LCD_5966508_DELAY;
		clear_bit (LCD_5966508_PORT5, LCD_5966508_E);
		pt = (in & 0x0f);
		LCD_5966508_DELAY;
		clear_bit(LCD_5966508_PORT0, LCD_5966508_BIT0);
		clear_bit(LCD_5966508_PORT1, LCD_5966508_BIT1);
		clear_bit(LCD_5966508_PORT2, LCD_5966508_BIT2);
		clear_bit(LCD_5966508_PORT3, LCD_5966508_BIT3);
		clear_bit(LCD_5966508_PORT4, LCD_5966508_RS);
		clear_bit(LCD_5966508_PORT5, LCD_5966508_E);
		if (pt & 0x01)
		    set_bit(LCD_5966508_PORT0, LCD_5966508_BIT0);
		if (pt & 0x02)
		    set_bit(LCD_5966508_PORT1, LCD_5966508_BIT1);
		if (pt & 0x04)
		    set_bit(LCD_5966508_PORT2, LCD_5966508_BIT2);
		if (pt & 0x08)
		    set_bit(LCD_5966508_PORT3, LCD_5966508_BIT3);
		if (mask)
		    set_bit(LCD_5966508_PORT4, LCD_5966508_RS);
		LCD_5966508_DELAY;
		set_bit (LCD_5966508_PORT5, LCD_5966508_E);
		LCD_5966508_DELAY;
		clear_bit (LCD_5966508_PORT5, LCD_5966508_E);
		LCD_5966508_DELAY;
}

static void FCD_LCDDisplay0_Start()
{
	
		set_bit(LCD_5966508_DDR0, LCD_5966508_BIT0);
		set_bit(LCD_5966508_DDR1, LCD_5966508_BIT1);
		set_bit(LCD_5966508_DDR2, LCD_5966508_BIT2);
		set_bit(LCD_5966508_DDR3, LCD_5966508_BIT3);
		set_bit(LCD_5966508_DDR4, LCD_5966508_RS);
		set_bit(LCD_5966508_DDR5, LCD_5966508_E);

		Wdt_Delay_Ms(12);

		FCD_LCDDisplay0_RawSend(0x33, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x33, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x32, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x2c, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x06, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x0c, 0);
		Wdt_Delay_Ms(2);

		//clear the display
		FCD_LCDDisplay0_RawSend(0x01, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x02, 0);
		Wdt_Delay_Ms(2);

}

static void FCD_LCDDisplay0_Clear()
{
	
		FCD_LCDDisplay0_RawSend(0x01, 0);
		Wdt_Delay_Ms(2);
		FCD_LCDDisplay0_RawSend(0x02, 0);
		Wdt_Delay_Ms(2);

}

static void FCD_LCDDisplay0_PrintASCII(char Character)
{
	
		FCD_LCDDisplay0_RawSend(Character, 0x10);

}

static void FCD_LCDDisplay0_Command(char in)
{
	
		FCD_LCDDisplay0_RawSend(in, 0);
		Wdt_Delay_Ms(2);

}

static void FCD_LCDDisplay0_Cursor(char x, char y)
{
	
	  #if (LCD_5966508_ROWCNT == 1)
	    y=0x80;
	  #endif

	  #if (LCD_5966508_ROWCNT == 2)
		if (y==0)
			y=0x80;
		else
			y=0xc0;
	  #endif

	  #if (LCD_5966508_ROWCNT == 4)
		if (y==0)
			y=0x80;
		else if (y==1)
			y=0xc0;

		#if (LCD_5966508_COLCNT == 16)
			else if (y==2)
				y=0x90;
			else
				y=0xd0;
		#endif

		#if (LCD_5966508_COLCNT == 20)
			else if (y==2)
				y=0x94;
			else
				y=0xd4;
		#endif
	  #endif

		FCD_LCDDisplay0_RawSend(y+x, 0);
		Wdt_Delay_Ms(2);

}

static void FCD_LCDDisplay0_PrintNumber(short Number)
{
	
		short tmp_int;
		char tmp_byte;
		if (Number < 0)
		{
			FCD_LCDDisplay0_RawSend('-', 0x10);
			Number = 0 - Number;
		}

		tmp_int = Number;
		if (Number >= 10000)
		{
			tmp_byte = tmp_int / 10000;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 10000;
				tmp_byte--;
			}
		}
		if (Number >= 1000)
		{
			tmp_byte = tmp_int / 1000;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 1000;
				tmp_byte--;
			}
		}
		if (Number >= 100)
		{
			tmp_byte = tmp_int / 100;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 100;
				tmp_byte--;
			}
		}
		if (Number >= 10)
		{
			tmp_byte = tmp_int / 10;
			FCD_LCDDisplay0_RawSend('0' + tmp_byte, 0x10);

			while (tmp_byte > 0)
			{
				tmp_int = tmp_int - 10;
				tmp_byte--;
			}
		}
		FCD_LCDDisplay0_RawSend('0' + tmp_int, 0x10);

}

static void FCD_LCDDisplay0_PrintString(char* String, char MSZ_String)
{
	
		char idx;
		for (idx=0; idx<MSZ_String; idx++)
		{
			if (String[idx]==0)
			{
				break;
			}
			FCD_LCDDisplay0_RawSend(String[idx], 0x10);
		}

}

static void FCD_LCDDisplay0_ScrollDisplay(char Direction, char Num_Positions)
{
	
		char cmd = 0;
		char count;

		//Choose the direction
		switch (Direction)
		{
			case 0:
			case 'l':
			case 'L':

				cmd = 0x18;
				break;

			case 1:
			case 'r':
			case 'R':

				cmd = 0x1C;
				break;

			default:
				break;
		}

		//If direction accepted then scroll the specified amount
		if (cmd)
		{
			for (count = 0; count < Num_Positions; count++)
				FCD_LCDDisplay0_Command(cmd);
		}

}

static void FCD_LCDDisplay0_ClearLine(char Line)
{
	
		char count;
		char rowcount;

		//Define number of columns per line
		#if (LCD_5966508_ROWCNT == 1)
			rowcount=80;
		#endif

		#if (LCD_5966508_ROWCNT == 2)
			rowcount=40;
		#endif

		#if (LCD_5966508_ROWCNT == 4)
			#if (LCD_5966508_COLCNT == 16)
				rowcount=16;
			#endif
			#if (LCD_5966508_COLCNT == 20)
				rowcount=20;
			#endif
		#endif

		//Start at beginning of the line
		FCD_LCDDisplay0_Cursor (0, Line);

		//Send out spaces to clear line
		for (count = 0; count < rowcount; count++)
			FCD_LCDDisplay0_RawSend(' ', 0x10);

		//Move back to the beginning of the line.
		FCD_LCDDisplay0_Cursor (0, Line);

}

static void FCD_LCDDisplay0_RAM_Write(char nIdx, char d0, char d1, char d2, char d3, char d4, char d5, char d6, char d7)
{
	   //set CGRAM address
	   FCD_LCDDisplay0_RawSend(64 + (nIdx << 3), 0);
	   delay_ms(2);

	   //write CGRAM data
	   FCD_LCDDisplay0_RawSend(d0, 0x10);
	   FCD_LCDDisplay0_RawSend(d1, 0x10);
	   FCD_LCDDisplay0_RawSend(d2, 0x10);
	   FCD_LCDDisplay0_RawSend(d3, 0x10);
	   FCD_LCDDisplay0_RawSend(d4, 0x10);
	   FCD_LCDDisplay0_RawSend(d5, 0x10);
	   FCD_LCDDisplay0_RawSend(d6, 0x10);
	   FCD_LCDDisplay0_RawSend(d7, 0x10);

	   //Clear the display
	   FCD_LCDDisplay0_RawSend(0x01, 0);
	   delay_ms(2);
	   FCD_LCDDisplay0_RawSend(0x02, 0);
	   delay_ms(2);
}



//ADC(0): //Macro implementations


static void FCD_ADC0_SampleADC()
{
	
		#define MX_ADC_CHANNEL		0
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		(1 - 0)

		char ddc;
		volatile char cnt;

		ddc = DDRC;

		//turn selected ADC on
		DDRC &= ~(1 << MX_ADC_CHANNEL);
		ADCSRA = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		ADCSRA |= (1 << ADSC);
		while(ADCSRA & (1 << ADSC));

		DDRC = ddc;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC0_ReadAsByte()
{
	
		FCD_ADC0_SampleADC();

		return ADCH;

}

static short FCD_ADC0_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC0_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC0_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC0_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC0_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}



//LED(0): //Macro implementations


static void FCD_LED0_LEDOn()
{
	
		DDRD = DDRD | 1;			//Convert pin to output

		if( 1 )					//Active high polarity
			PORTD = PORTD | 1;
		else					//Active low polarity
			PORTD = PORTD & ~1;

}

static void FCD_LED0_LEDOff()
{
	
		DDRD = DDRD | 1;			//Convert pin to output

		if( 1 )					//Active high polarity
			PORTD = PORTD & ~1;
		else					//Active low polarity
			PORTD = PORTD | 1;

}



//ADC(1): //Macro implementations


static void FCD_ADC1_SampleADC()
{
	
		#define MX_ADC_CHANNEL		1
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		(1 - 0)

		char ddc;
		volatile char cnt;

		ddc = DDRC;

		//turn selected ADC on
		DDRC &= ~(1 << MX_ADC_CHANNEL);
		ADCSRA = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		ADCSRA |= (1 << ADSC);
		while(ADCSRA & (1 << ADSC));

		DDRC = ddc;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC1_ReadAsByte()
{
	
		FCD_ADC1_SampleADC();

		return ADCH;

}

static short FCD_ADC1_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC1_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC1_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC1_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC1_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC1_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}



//ADC(2): //Macro implementations


static void FCD_ADC2_SampleADC()
{
	
		#define MX_ADC_CHANNEL		3
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		(1 - 0)

		char ddc;
		volatile char cnt;

		ddc = DDRC;

		//turn selected ADC on
		DDRC &= ~(1 << MX_ADC_CHANNEL);
		ADCSRA = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		ADCSRA |= (1 << ADSC);
		while(ADCSRA & (1 << ADSC));

		DDRC = ddc;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC2_ReadAsByte()
{
	
		FCD_ADC2_SampleADC();

		return ADCH;

}

static short FCD_ADC2_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC2_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC2_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC2_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC2_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC2_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}



//ADC(3): //Macro implementations


static void FCD_ADC3_SampleADC()
{
	
		#define MX_ADC_CHANNEL		2
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		(1 - 0)

		char ddc;
		volatile char cnt;

		ddc = DDRC;

		//turn selected ADC on
		DDRC &= ~(1 << MX_ADC_CHANNEL);
		ADCSRA = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		ADCSRA |= (1 << ADSC);
		while(ADCSRA & (1 << ADSC));

		DDRC = ddc;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC3_ReadAsByte()
{
	
		FCD_ADC3_SampleADC();

		return ADCH;

}

static short FCD_ADC3_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC3_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC3_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC3_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC3_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC3_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}

//Macro implementations

void FCM_tmr0()
{
	
	//Calculation
	//Calculation:
	//  time = time+1
	FCV_TIME = FCV_TIME+1;
	

}

int main()
{
	//Wind turbine multimeter
	
	//Initialisation
	MCUCSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	
	//Call Component Macro
	//Call Component Macro: LCDDisplay(0)::Start
	FCD_LCDDisplay0_Start();


	//Loop
	//Loop: While 1
	while (1)
	{
		//???????? ????????? ?????
		//Decision: Port_D2=0 AND Flag_PD=0?
		if (FCV_PORT_D2==0 & FCV_FLAG_PD==0)
		{
			//????????? ????????? ????? ?????
			//Calculation:
			//  Flag_PD = 1
			FCV_FLAG_PD = 1;
			

			//????? ????????? ???????
			//Call Component Macro: LED(0)::LEDOff
			FCD_LED0_LEDOff();


		} else {
			//Input
			//Input: D2 -> Port_D2
			DDRD = DDRD & 0xfb;
			FCV_PORT_D2 = ((PIND & 0x04) == 0x04);


		}


		//???? ?? ????? 1 ????????? TMR0 ?? ?????????? ????????
		//Decision: Port_D2=1 AND Flag_PD=1?
		if (FCV_PORT_D2==1 & FCV_FLAG_PD==1)
		{
			//Calculation
			//Calculation:
			//  Flag_PD = 0
			FCV_FLAG_PD = 0;
			

			//Call Component Macro
			//Call Component Macro: LED(0)::LEDOn
			FCD_LED0_LEDOn();


			//2-? ??????? - ????????? TMR0
			//Decision: flag_t=1?
			if (FCV_FLAG_T==1)
			{
				//Calculation
				//Calculation:
				//  flag_t = 0
				FCV_FLAG_T = 0;
				

				//Interrupt
				//Interrupt: Disable TMR0
				TIMSK &= ~(1 << TOIE0);


				//? ??? ????? ????? ?????????? RPM :(
				//Calculation:
				//  freq_float = time*0.008
				//  freq_float = 1/freq_float*60
				FCV_FREQ_FLOAT = FCV_TIME*0.008;
				FCV_FREQ_FLOAT = 1/FCV_FREQ_FLOAT*60;
				

				//Calculation
				//Calculation:
				//  time = 0
				FCV_TIME = 0;
				

			} else {
				//Interrupt
				//Interrupt: Enable TMR0
				TCCR0 &= 0xf8;
				TCCR0 |= 0x04;
				sei();
				TIMSK |= (1 << TOIE0);


				//Calculation
				//Calculation:
				//  flag_t = 1
				FCV_FLAG_T = 1;
				

			}


		}


		//?????? ???????? ???????
		//Calculation:
		//  count_d = count_d+1
		FCV_COUNT_D = FCV_COUNT_D+1;
		

		//Decision
		//Decision: count_d=3000?
		if (FCV_COUNT_D==3000)
		{
			//Call Component Macro
			//Call Component Macro: Uin=ADC(1)::ReadAsString
			FCD_ADC1_ReadAsString(FCV_UIN, 4);


			//Call Component Macro
			//Call Component Macro: Iin=ADC(0)::ReadAsString
			FCD_ADC0_ReadAsString(FCV_IIN, 4);


			//Call Component Macro
			//Call Component Macro: Ubat=ADC(2)::ReadAsString
			FCD_ADC2_ReadAsString(FCV_UBAT, 4);


			//Call Component Macro
			//Call Component Macro: Ibat=ADC(3)::ReadAsString
			FCD_ADC3_ReadAsString(FCV_IBAT, 4);


			//String Manipulation
			//String Manipulation:
			//  D_Uin = "Uin=" + Uin + "V"
			FCI_CONCATENATE("Uin=",4,FCV_UIN,FCSZ_UIN,FCI_TMP_STR,20);
			FCI_CONCATENATE(FCI_TMP_STR,20,"V",1,FCV_D_UIN,FCSZ_D_UIN);
			

			//String Manipulation
			//String Manipulation:
			//  D_Iin = "Iin=" + Iin + "A"
			FCI_CONCATENATE("Iin=",4,FCV_IIN,FCSZ_IIN,FCI_TMP_STR,20);
			FCI_CONCATENATE(FCI_TMP_STR,20,"A",1,FCV_D_IIN,FCSZ_D_IIN);
			

			//String Manipulation
			//String Manipulation:
			//  D_Ubat = "Ubat=" + Ubat + "V"
			FCI_CONCATENATE("Ubat=",5,FCV_UBAT,FCSZ_UBAT,FCI_TMP_STR,20);
			FCI_CONCATENATE(FCI_TMP_STR,20,"V",1,FCV_D_UBAT,FCSZ_D_UBAT);
			

			//String Manipulation
			//String Manipulation:
			//  D_Ibat = "Ibat=" + Ibat + "A"
			FCI_CONCATENATE("Ibat=",5,FCV_IBAT,FCSZ_IBAT,FCI_TMP_STR,20);
			FCI_CONCATENATE(FCI_TMP_STR,20,"A",1,FCV_D_IBAT,FCSZ_D_IBAT);
			

			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::Cursor(0, 0)
			FCD_LCDDisplay0_Cursor(0, 0);


			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::PrintString(D_Uin)
			FCD_LCDDisplay0_PrintString(FCV_D_UIN,FCSZ_D_UIN);


			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::Cursor(0, 1)
			FCD_LCDDisplay0_Cursor(0, 1);


			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::PrintString(D_Iin)
			FCD_LCDDisplay0_PrintString(FCV_D_IIN,FCSZ_D_IIN);


			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::Cursor(10, 0)
			FCD_LCDDisplay0_Cursor(10, 0);


			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::PrintString(D_Ubat)
			FCD_LCDDisplay0_PrintString(FCV_D_UBAT,FCSZ_D_UBAT);


			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::Cursor(10, 1)
			FCD_LCDDisplay0_Cursor(10, 1);


			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::PrintString(D_Ibat)
			FCD_LCDDisplay0_PrintString(FCV_D_IBAT,FCSZ_D_IBAT);


			//String Manipulation
			//String Manipulation:
			//  RPM = FloatToString$(freq_float)
			//  D_RPM = "F=" + RPM + "RPM"
			FCI_FLOAT_TO_STRING(FCV_FREQ_FLOAT,6,FCV_RPM,FCSZ_RPM);
			FCI_CONCATENATE("F=",2,FCV_RPM,FCSZ_RPM,FCI_TMP_STR,20);
			FCI_CONCATENATE(FCI_TMP_STR,20,"RPM",3,FCV_D_RPM,FCSZ_D_RPM);
			

			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::Cursor(21, 0)
			FCD_LCDDisplay0_Cursor(21, 0);


			//Call Component Macro
			//Call Component Macro: LCDDisplay(0)::PrintString(D_RPM)
			FCD_LCDDisplay0_PrintString(FCV_D_RPM,FCSZ_D_RPM);


			//Calculation
			//Calculation:
			//  count_d = 0
			FCV_COUNT_D = 0;
			

		}


	}


	mainendloop: goto mainendloop;
}

	//Handler code for [TMR0]
	#ifndef MX_TIMER0OVF_HANDLER
	#define MX_TIMER0OVF_HANDLER
	ISR(TIMER0_OVF_vect)
	{
		FCM_tmr0();
	}
	#else
	#warning The <TIMER0 OVF> interrupt has previously been enabled, so the macro <tmr0> may never get called.
	#endif




